/* ___________________________________________________________________________
** |*************************************************************************|
** |*||*||*|
** |*| Set TAB to 4 for best readable file layout.  |*|  C++ MaxonDev 4.0  |*|
** |*|______________________________________________|*|____________________|*|
** |*************************************************************************|
** |*||*||*|
** |*|               |*|  $Id: extra_lib.h (28.04.01)                      |*|
** |*| ###### ###### |*|  RhoSigma Source based on NDK 3.1 Includes 40.15  |*|
** |*| ##  ## ##   # |*| _________________________________________________ |*|
** |*| ##  ##  ##    |*|                                                   |*|
** |*| ######   ##   |*|  C/C++ function pragmas of the extra.library      |*|
** |*| ##      ##    |*|                                                   |*|
** |*| ##     ##   # |*|  |*|
** |*| ##     ###### |*|  Copyright  1998-2001 RhoSigma, Roland Heyder    |*|
** |*|               |*|  All Rights Reserved.                             |*|
** |*|_______________|*|___________________________________________________|*|
** |*************************************************************************|
** 
*/

#ifndef _INCLUDE_PRAGMA_EXTRA_LIB_H
#define _INCLUDE_PRAGMA_EXTRA_LIB_H

#ifndef CLIB_EXTRA_PROTOS_H
#include <rhosigma/extra_protos.h>
#endif

#if defined(AZTEC_C) || defined(__MAXON__) || defined(__STORM__)
#pragma amicall(ExtraBase,0x02A,BAMCheckSum(a0))
#pragma amicall(ExtraBase,0x030,BootBlockSum(a0))
#pragma amicall(ExtraBase,0x036,DiskBlockSum(a0))
#pragma amicall(ExtraBase,0x03C,OpenBuf())
#pragma amicall(ExtraBase,0x042,CloseBuf(a0))
#pragma amicall(ExtraBase,0x048,FileToBuf(a0))
#pragma amicall(ExtraBase,0x04E,BufToFile(a0,a1))
#pragma amicall(ExtraBase,0x054,ClearBuf(a0))
#pragma amicall(ExtraBase,0x05A,DuplicateBuf(a0))
#pragma amicall(ExtraBase,0x060,BufInfo(a0))
#pragma amicall(ExtraBase,0x066,SeekBuf(a0,d0,d1))
#pragma amicall(ExtraBase,0x06C,Store(a0,a1,d0))
#pragma amicall(ExtraBase,0x072,InsertBuf(a0,a1))
#pragma amicall(ExtraBase,0x078,InsertFile(a0,a1))
#pragma amicall(ExtraBase,0x07E,Replace(a0,a1,d0,d1))
#pragma amicall(ExtraBase,0x084,Get(a0))
#pragma amicall(ExtraBase,0x08A,Clear(a0,d0))
#pragma amicall(ExtraBase,0x090,FindData(a0,d0,a1,d1))
#pragma amicall(ExtraBase,0x096,FindNext(a0,d0))
#pragma amicall(ExtraBase,0x09C,FindPrev(a0,d0))
#pragma amicall(ExtraBase,0x0A2,FreeFinds(a0))
#pragma amicall(ExtraBase,0x0A8,SetBookmark(a0,d0))
#pragma amicall(ExtraBase,0x0AE,GotoBookmark(a0,d0))
#pragma amicall(ExtraBase,0x0B4,FindString(a0,d0,a1,d1))
#pragma amicall(ExtraBase,0x0BA,GetLength(a0,d0,d1))
#pragma amicall(ExtraBase,0x0C0,LastError())
#pragma amicall(ExtraBase,0x0C6,LongToString(d0,d1))
#pragma amicall(ExtraBase,0x0CC,StringToLong(a0,d0))
#pragma amicall(ExtraBase,0x0D2,PackByteRun1(a0,d0,a1,d1))
#pragma amicall(ExtraBase,0x0D8,UnpackByteRun1(a0,a1,d0))
#pragma amicall(ExtraBase,0x0DE,PrintIoError(d0))
#pragma amicall(ExtraBase,0x0E4,FlipCase(a0,d0,d1))
#pragma amicall(ExtraBase,0x0EA,CmpMem(a0,a1,d0))
#pragma amicall(ExtraBase,0x0F0,CopyMemI(a0,a1,d0))
#pragma amicall(ExtraBase,0x0F6,FillMem(a0,d0,d1))
#pragma amicall(ExtraBase,0x0FC,GetMem(d0,d1))
#pragma amicall(ExtraBase,0x102,UnGetMem(a0))
#pragma amicall(ExtraBase,0x108,OutlineOff(a0))
#pragma amicall(ExtraBase,0x10E,OutlineOn(a0))
#pragma amicall(ExtraBase,0x114,SetOPen(a0,d0))
#pragma amicall(ExtraBase,0x11A,SpecText(a0,a1,d0,d1))
#pragma amicall(ExtraBase,0x120,SpecTextPrefs(d0,d1,d2,d3,d4,d5))
#pragma amicall(ExtraBase,0x126,ShowMsg(a0,d0,d1,d2))
#pragma amicall(ExtraBase,0x12C,v2_OpenBuf(d0))
#pragma amicall(ExtraBase,0x132,v2_FileToBuf(a0,d0))
#pragma amicall(ExtraBase,0x138,v2_DuplicateBuf(a0,d0))
#endif
#if defined(_DCC) || defined(__SASC)
#pragma libcall ExtraBase BAMCheckSum          02A 801
#pragma libcall ExtraBase BootBlockSum         030 801
#pragma libcall ExtraBase DiskBlockSum         036 801
#pragma libcall ExtraBase OpenBuf              03C 00
#pragma libcall ExtraBase CloseBuf             042 801
#pragma libcall ExtraBase FileToBuf            048 801
#pragma libcall ExtraBase BufToFile            04E 9802
#pragma libcall ExtraBase ClearBuf             054 801
#pragma libcall ExtraBase DuplicateBuf         05A 801
#pragma libcall ExtraBase BufInfo              060 801
#pragma libcall ExtraBase SeekBuf              066 10803
#pragma libcall ExtraBase Store                06C 09803
#pragma libcall ExtraBase InsertBuf            072 9802
#pragma libcall ExtraBase InsertFile           078 9802
#pragma libcall ExtraBase Replace              07E 109804
#pragma libcall ExtraBase Get                  084 801
#pragma libcall ExtraBase Clear                08A 0802
#pragma libcall ExtraBase FindData             090 190804
#pragma libcall ExtraBase FindNext             096 0802
#pragma libcall ExtraBase FindPrev             09C 0802
#pragma libcall ExtraBase FreeFinds            0A2 801
#pragma libcall ExtraBase SetBookmark          0A8 0802
#pragma libcall ExtraBase GotoBookmark         0AE 0802
#pragma libcall ExtraBase FindString           0B4 190804
#pragma libcall ExtraBase GetLength            0BA 10803
#pragma libcall ExtraBase LastError            0C0 00
#pragma libcall ExtraBase LongToString         0C6 1002
#pragma libcall ExtraBase StringToLong         0CC 0802
#pragma libcall ExtraBase PackByteRun1         0D2 190804
#pragma libcall ExtraBase UnpackByteRun1       0D8 09803
#pragma libcall ExtraBase PrintIoError         0DE 001
#pragma libcall ExtraBase FlipCase             0E4 10803
#pragma libcall ExtraBase CmpMem               0EA 09803
#pragma libcall ExtraBase CopyMemI             0F0 09803
#pragma libcall ExtraBase FillMem              0F6 10803
#pragma libcall ExtraBase GetMem               0FC 1002
#pragma libcall ExtraBase UnGetMem             102 801
#pragma libcall ExtraBase OutlineOff           108 801
#pragma libcall ExtraBase OutlineOn            10E 801
#pragma libcall ExtraBase SetOPen              114 0802
#pragma libcall ExtraBase SpecText             11A 109804
#pragma libcall ExtraBase SpecTextPrefs        120 54321006
#pragma libcall ExtraBase ShowMsg              126 210804
#pragma libcall ExtraBase v2_OpenBuf           12C 001
#pragma libcall ExtraBase v2_FileToBuf         132 0802
#pragma libcall ExtraBase v2_DuplicateBuf      138 0802
#endif

#endif	/*  _INCLUDE_PRAGMA_EXTRA_LIB_H  */

