; ___________________________________________________________________________
; |*************************************************************************|
; |*||*||*|
; |*| Set TAB to 15 for best readable file layout. |*| HiSoft DevPac 3.04 |*|
; |*|______________________________________________|*|____________________|*|
; |*************************************************************************|
; |*||*||*|
; |*|               |*|  $Id: AlertDemo.ASM (28.04.01)                    |*|
; |*| ###### ###### |*|  RhoSigma Source based on NDK 3.1 Includes 40.15  |*|
; |*| ##  ## ##   # |*| _________________________________________________ |*|
; |*| ##  ##  ##    |*|                                                   |*|
; |*| ######   ##   |*|  Demo to show use of DATEXT-Macro (settings.i)    |*|
; |*| ##      ##    |*|                                                   |*|
; |*| ##     ##   # |*|  |*|
; |*| ##     ###### |*|  Copyright  1998-2001 RhoSigma, Roland Heyder    |*|
; |*|               |*|  All Rights Reserved.                             |*|
; |*|_______________|*|___________________________________________________|*|
; |*************************************************************************|
; 

; ACHTUNG: Die Macros zum Aufruf der OS-Funktionen, welche in dieser Source
;  verwendet werden, entsprechen nicht denen, die in den offiziellen
;          Includes in den entsprechenden _lib.i Dateien definiert sind.
;           Vielmehr habe ich hierfr mein eigenes Macro entwickelt. Dieses
;          Macro ist im Kontext fr alle Libraries identisch und entspicht
;          dem, welches in dem Include extra_lib.i fr die mitgelieferte
;          extra.library definiert ist !!

	OPT	P=68000,NODEBUG,AMIGA
	OPT	O1+,O2+,O3+,O4+,O5+,O6+,O7+,O10+,O11+
	OPT	CHKBIT,CHKIMM,TYPE,USER
	OUTPUT	AlertDemoASM

	INCDIR	Include:
	INCLUDE	lvo/exec_lib.i
	INCLUDE	lvo/intuition_lib.i
	INCLUDE	rhosigma/settings.i

	jmp	SysStart

	dc.b	"$VER: AlertDemoASM 2.14 (28.04.01)",13,10,0
	dc.w	0

SysStart	lea	IntuName(pc),a1        ; intuition ffnen
	moveq	#33,d0
	DOEXEC	OpenLibrary
	move.l	d0,_IntuitionBase
	beq.s	.error	        ; ffnen fehlgeschlagen

	lea	AlertTxt1(pc),a0       ; DisplayAlert ausfhren
	moveq	#0,d0
	moveq	#40,d1
	DOINT	DisplayAlert

	lea	AlertTxt2(pc),a0       ; DisplayAlert ausfhren
	moveq	#0,d0
	moveq	#20,d1
	DOINT	DisplayAlert,OK

	lea	AlertTxt3(pc),a0       ; DisplayAlert ausfhren
	moveq	#0,d0
	moveq	#50,d1
	DOINT	DisplayAlert,OK

	lea	AlertTxt4(pc),a0       ; DisplayAlert ausfhren
	moveq	#0,d0
	moveq	#30,d1
	DOINT	DisplayAlert,OK

	movea.l	_IntuitionBase(pc),a1  ; intuition schlieen
	DOEXEC	CloseLibrary
	moveq	#0,d0	; kein CLI-Fehler (Programmende)
	bra.s	.exit

.error	moveq	#20,d0    ; CLI-Rckgabe FAIL (keine intuition)
.exit	rts

IntuName	dc.b	"intuition.library",0
_IntuitionBase	dc.l	0

AlertTxt1	DATEXT	100,12,<linke Seite>    ; kein END-Flag, absolute
	DATEXT	444,12,<rechte Seite>   ; X-Koordinaten
	DATEXT	DATPOS_C,22,<zentriert> ; kein END-Flag, zentriert
	DATEXT	DATPOS_C,32,<Ende>,END  ; END-Flag, zentriert

AlertTxt2	DATEXT	112,12,<Oder>
	DATEXT	212,12,<alles>
	DATEXT	312,12,<in>
	DATEXT	412,12,<einer>
	DATEXT	512,12,<Zeile !!>,END

AlertTxt3	DATEXT	DATPOS_C,12,<Oder>
	DATEXT	DATPOS_C,22,<alles>
	DATEXT	DATPOS_C,32,<zentriert>
	DATEXT	DATPOS_C,42,<!!>,END

AlertTxt4	DATEXT	DATPOS_L,12,<linksbndig>
	DATEXT	DATPOS_C,12,<zentriert>
	DATEXT	DATPOS_R,12,<rechtsbndig>
	DATEXT	200,22,<absolute X-Pos 200 v.l.>,END
