/* ___________________________________________________________________________
** |*************************************************************************|
** |*||*||*|
** |*| Set TAB to 4 for best readable file layout.  |*|  C++ MaxonDev 4.0  |*|
** |*|______________________________________________|*|____________________|*|
** |*************************************************************************|
** |*||*||*|
** |*|               |*|  $Id: AlertDemo.C (28.04.01)                      |*|
** |*| ###### ###### |*|  RhoSigma Source based on NDK 3.1 Includes 40.15  |*|
** |*| ##  ## ##   # |*| _________________________________________________ |*|
** |*| ##  ##  ##    |*|                                                   |*|
** |*| ######   ##   |*|  Demo to show use of DATEXT-Macro (settings.h)    |*|
** |*| ##      ##    |*|                                                   |*|
** |*| ##     ##   # |*|  |*|
** |*| ##     ###### |*|  Copyright  1998-2001 RhoSigma, Roland Heyder    |*|
** |*|               |*|  All Rights Reserved.                             |*|
** |*|_______________|*|___________________________________________________|*|
** |*************************************************************************|
** 
*/

/*
** ----------------------------------------------------
** Dieses Beispiel ist sowohl ANSI-C sowie C++ tauglich
** ----------------------------------------------------
*/

/* Weitere Source-Dateien */
#include <rhosigma/rhosigma.c>	/* Nicht die feine englische Art, */
								/* sollte einzeln compiliert und  */
								/* spter zugelinkt werden ...    */

/* Includes */
#include <exec/types.h>
#include <wbstartup.h>
#include <rhosigma/settings.h>

/* Prototypes & Pragmas */
#include <pragma/exec_lib.h>
#include <pragma/intuition_lib.h>

/* Version-String */
STATIC TEXT vID[] = "$VER: AlertDemoC 2.14 (28.04.01) compiled on "__DATE__\
															 " at "__TIME__"\r\n";

struct Library *IntuitionBase = NULL;

DATEXT(teil1,100,12,linke Seite,FALSE);		/* kein END-Flag, absolute	*/
DATEXT(teil2,444,12,rechte Seite,FALSE);	/* X-Koordinaten			*/
DATEXT(teil3,DATPOS_C,22,zentriert,FALSE);	/* kein END-Flag, zentriert	*/
DATEXT(teil4,DATPOS_C,32,Ende,TRUE);		/* END-Flag, zentriert		*/

void main()
{
	/* Kann auch innerhalb von Funktionen stehen */
	DATEXT(teil5,DATPOS_L,12,linksbndig,FALSE);
	DATEXT(teil6,DATPOS_C,12,zentriert,FALSE);
	DATEXT(teil7,DATPOS_R,12,rechtsbndig,FALSE);
	DATEXT(teil8,200,22,absolute X-Pos 200 v.l.,TRUE);

	/* Teilstrings vorbereiten (Wichtig) */
	DAJOIN(8,&teil1,&teil2,&teil3,&teil4,
			 &teil5,&teil6,&teil7,&teil8);

	IntuitionBase = OpenLibrary("intuition.library",33);

	/* Alerts ausfhren */
	/* Als Param-Pointer verwenden wir die gecastete Referenz des */
	/* jeweils ersten Teilstrings eines Parameterstrings.		  */
	DisplayAlert(NULL,(STRPTR) &teil1,40L);
	DisplayAlert(NULL,(STRPTR) &teil5,30L);

	CloseLibrary(IntuitionBase);
	return;
}

