; ___________________________________________________________________________
; |*************************************************************************|
; |*||*||*|
; |*| Set TAB to 15 for best readable file layout. |*| HiSoft DevPac 3.04 |*|
; |*|______________________________________________|*|____________________|*|
; |*************************************************************************|
; |*||*||*|
; |*|               |*|  $Id: ShowMsgDemo.ASM (28.04.01)                  |*|
; |*| ###### ###### |*|  RhoSigma Source based on NDK 3.1 Includes 40.15  |*|
; |*| ##  ## ##   # |*| _________________________________________________ |*|
; |*| ##  ##  ##    |*|                                                   |*|
; |*| ######   ##   |*|  Demo to show use of extra/ShowMsg() and Macros   |*|
; |*| ##      ##    |*|                                                   |*|
; |*| ##     ##   # |*|  |*|
; |*| ##     ###### |*|  Copyright  1998-2001 RhoSigma, Roland Heyder    |*|
; |*|               |*|  All Rights Reserved.                             |*|
; |*|_______________|*|___________________________________________________|*|
; |*************************************************************************|
; 

; ACHTUNG: Die Macros zum Aufruf der OS-Funktionen, welche in dieser Source
;  verwendet werden, entsprechen nicht denen, die in den offiziellen
;          Includes in den entsprechenden _lib.i Dateien definiert sind.
;           Vielmehr habe ich hierfr mein eigenes Macro entwickelt. Dieses
;          Macro ist im Kontext fr alle Libraries identisch und entspicht
;          dem, welches in dem Include extra_lib.i fr die mitgelieferte
;          extra.library definiert ist !!

	OPT	P=68000,NODEBUG,AMIGA
	OPT	O1+,O2+,O3+,O4+,O5+,O6+,O7+,O10+,O11+
	OPT	CHKBIT,CHKIMM,TYPE,USER
	OUTPUT	ShowMsgDemoASM

	INCDIR	Include:
	INCLUDE	lvo/exec_lib.i
	INCLUDE	rhosigma/extra_lib.i
	INCLUDE	rhosigma/extradefs.i

	jmp	SysStart

	dc.b	"$VER: ShowMsgDemoASM 2.14 (28.04.01)",13,10,0
	dc.w	0

SysStart	lea	ExtraName(pc),a1        ; extra.library ffnen
	moveq	#1,d0
	DOEXEC	OpenLibrary
	move.l	d0,_ExtraBase
	beq.s	.error	         ; ffnen fehlgeschlagen

	lea	AlertTxt1(pc),a0        ; ShowMsg ausfhren
	moveq	#0,d0
	moveq	#40,d1
	moveq	#0,d2
	DOEXTRA	ShowMsg

	lea	AlertTxt2(pc),a0        ; ShowMsg ausfhren
	moveq	#0,d0
	moveq	#20,d1
	moveq	#0,d2
	DOEXTRA	ShowMsg,OK

	lea	AlertTxt3(pc),a0        ; ShowMsg ausfhren
	moveq	#0,d0
	moveq	#50,d1
	moveq	#0,d2
	DOEXTRA	ShowMsg,OK

	lea	AlertTxt4(pc),a0        ; ShowMsg ausfhren
	moveq	#0,d0
	moveq	#30,d1
	moveq	#0,d2
	DOEXTRA	ShowMsg,OK

	lea	AlertTxt5(pc),a0        ; ShowMsg ausfhren
	moveq	#0,d0
	moveq	#46,d1
	moveq	#0,d2
	DOEXTRA	ShowMsg,OK

	lea	AlertTxt6(pc),a0        ; ShowMsg ausfhren
	moveq	#0,d0
	moveq	#30,d1
	move.l	#NewColor,d2
	DOEXTRA	ShowMsg,OK

	movea.l	_ExtraBase(pc),a1       ; extra.library schlieen
	DOEXEC	CloseLibrary
	moveq	#0,d0	   ; kein CLI-Fehler (Programmende)
	bra.s	.exit

.error	moveq	#20,d0    ; CLI-Rckgabe FAIL (keine extra.library)
.exit	rts

ExtraName	dc.b	"extra.library",0
_ExtraBase	dc.l	0

AlertTxt1	SMTEXT	100,6,<linke Seite>     ; kein END-Flag, absolute
	SMTEXT	444,6,<rechte Seite>    ; X-Koordinaten
	SMTEXT	SMTPOS_C,16,<zentriert> ; kein END-Flag, zentriert
	SMTEXT	SMTPOS_C,26,<Ende>,END  ; END-Flag, zentriert

AlertTxt2	SMTEXT	112,6,<Oder>
	SMTEXT	212,6,<alles>
	SMTEXT	312,6,<in>
	SMTEXT	412,6,<einer>
	SMTEXT	512,6,<Zeile !!>,END

AlertTxt3	SMTEXT	SMTPOS_C,6,<Oder>
	SMTEXT	SMTPOS_C,16,<alles>
	SMTEXT	SMTPOS_C,26,<zentriert>
	SMTEXT	SMTPOS_C,36,<!!>,END

AlertTxt4	SMTEXT	SMTPOS_L,6,<linksbndig>
	SMTEXT	SMTPOS_C,6,<zentriert>
	SMTEXT	SMTPOS_R,6,<rechtsbndig>
	SMTEXT	200,16,<absolute X-Pos 200 v.l.>,END

AlertTxt5	SMTEXTP	SMTPOS_C,6,9,11,11,STS_Plain,STM_Outline,<extra.library 2.118 - Copyright  1998-2001 - Roland Heyder>
	SMTEXTP	SMTPOS_C,18,9,15,15,STS_Plain,STM_Outline,<For registration send DM 15,- or the changed amount in other currencies to:>
	SMTEXTP	SMTPOS_C,30,9,13,13,STS_Plain,STM_Outline,<Roland Heyder - Oberstadt 44 - 38877 Benneckenstein - Germany>,END

NewColor	SMCOLOR 3,12,0,10	; einige Farben neudefinieren
	SMCOLOR 7,0,5,14
	SMCOLOR 11,12,15,0
	SMCOLOR 12,15,13,0
	SMCOLOR 15,15,0,0,END

; mann kann natrlich auch die beiden Macros fr die Texterstellung mischen

AlertTxt6	SMTEXTP	SMTPOS_L,6,3,9,1,STS_Underline,STM_Outline,<linksbndig>
	SMTEXT	SMTPOS_R,6,<rechtsbndig> ; genau wie 1.Teilsting
	SMTEXTP	SMTPOS_C,6,7,9,1,STS_Bold,STM_Shadow,<zentriert>
	SMTEXTP	200,16,12,9,1,STS_Italic,STM_Normal,<absolute X-Pos 200 v.l.>,END
