/* ___________________________________________________________________________
** |*************************************************************************|
** |*||*||*|
** |*| Set TAB to 4 for best readable file layout.  |*|  C++ MaxonDev 4.0  |*|
** |*|______________________________________________|*|____________________|*|
** |*************************************************************************|
** |*||*||*|
** |*|               |*|  $Id: rhosigma.h (28.04.01)                       |*|
** |*| ###### ###### |*|  RhoSigma Source based on NDK 3.1 Includes 40.15  |*|
** |*| ##  ## ##   # |*| _________________________________________________ |*|
** |*| ##  ##  ##    |*|                                                   |*|
** |*| ######   ##   |*|  Protos & defines for rhosigma.c support source   |*|
** |*| ##      ##    |*|                                                   |*|
** |*| ##     ##   # |*|  |*|
** |*| ##     ###### |*|  Copyright  1998-2001 RhoSigma, Roland Heyder    |*|
** |*|               |*|  All Rights Reserved.                             |*|
** |*|_______________|*|___________________________________________________|*|
** |*************************************************************************|
** 
*/

#ifndef		RHOSIGMA_H
#define		RHOSIGMA_H

#ifndef		EXEC_TYPES_H
#include	<exec/types.h>
#endif

/*
** -------------------------------------------
** In RhoSigma-Includes deklarierte Funktionen
** -------------------------------------------
*/

#ifndef		RHOSIGMA_SETTINGS_H
#include	<rhosigma/settings.h>
#endif
#ifndef		RHOSIGMA_EXTRADEFS_H
#include	<rhosigma/extradefs.h>
#endif

/*
** ---------------------------------------------
** Ab hier folgen unabhngige Support-Funktionen
** ---------------------------------------------
*/

#ifdef __cplusplus
extern "C" {
#endif

/* Funktionen fr einfachen Device-IO */
APTR GetIOReq(UWORD Size);
APTR CopyIOReq(APTR OrigReq);
VOID FreeIOReq(APTR IOReq);
BYTE DoCMD(APTR IOReq,UWORD Comm);
VOID SendCMD(APTR IOReq,UWORD Comm);
BYTE WaitCMD(APTR IOReq);

#ifdef __cplusplus
}
#endif

#endif	/* RHOSIGMA_H */

